Subject: bug#57781: missing wallpaper command

From: Felix <[email-masked]>
Date: Sat, 17 Sep 2022 14:00:49 +0200

Stefan Kangas <[email-masked]> writes:

> Felix <[email-masked]> writes:
>
>> Neither swaybg nor wgb is running under gnome-shell with wayland.
>> Gnome has it's own way of setting wallpapers.
>> As kind of expected wbg depends on wlroots i guess.
>> I'm not shure how to check which wm/desktop is running.
>
> Does that mean that setting the wallpaper using `wallpaper-set' doesn't
> work when running gnome-shell under Wayland?

No it works under gnome-shell (if the light color scheme is active),
what i meant is that those wlroots dependend applications
(swaybg,wbg,hyprpaper ...)
are not working under gnome and probably not under kde.

>
> If you still have access to it, what is the value of the environment
> variables $XDG_CURRENT_DESKTOP, $WAYLAND_DISPLAY and $SWAYSOCK in this
> configuration?

On a fresh debian install with
- gnome-shell:
$XDG_CURRENT_DESKTOP is not set (i will check on arch linux later today)
$WAYLAND_DISPLAY = wayland-1
- sway:
$SWAYSOCK = /run/user/1000/sway-ipc.1000.13582.sock

>
> If you like, perhaps you could send the output of the `env' command to
> me privately.  Just edit out anything sensitive before sending it.
>

I will do that later today aswell.

>> wmctrl would be very usefull, but there is not garantee for it to be
>> installed.
>
> Thanks, I did not know about wmctrl.  I took a look at its website
>
>     https://sites.google.com/site/tstyblo/wmctrl
>
> but I could not find any way to set the wallpaper using it.  Maybe I
> missed it.  Do you know if it can be done, and if so, how?
>
> (We can check if it installed with `executable-find'.)
>

wmctrl is not for setting wallpapers, i meant that it would be a
convenient way to check which desktop/wm is running.

>> Another point is that:
>> ("gsettings" "set" "org.gnome.desktop.background" "picture-uri" "file://%f")
>> only effects the light scheme of gnome.
>> If you want to change the wallpaper of the dark scheme
>> ("gsettings" "set" "org.gnome.desktop.background" "picture-uri-dark" "file://%f")
>> is the command.
>> 'gsettings get org.gnome.desktop.interface color-scheme'
>> can be used to check which of both schemes is active.
>> It returns either 'prefer-dark' or 'prefer-light'
>> One could think about setting the wallpaper for both themes, or
>> only for the active color-scheme.
>
> Hmm, this is interesting.  It is clear that we need to extend
> wallpaper.el to run another command first, to decide which command
> should be run in various situations.  I will look into it.
>
>> I can check KDE later, but I don't expect wgb or swaybg to work there.

I'll include that later today (i'm on a train back home at the moment)

>
> That will be much appreciated.

>
> Thanks for all of the above, this is very useful.